<template src="./template.html"></template>

<script lang="ts">
import { Watch, getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import _ from "lodash";
var momentz = require("moment-timezone");
var moment = require("moment");

interface IBodyCreate {
  code: string;
  discount: number;
  status: boolean;
  discountType: number;
  dateFrom: string;
  dateTo?: string;
}

@Component({})
export default class AdminDiscountCreateComponent extends Vue {
  discount = {
    code: "",
    discount: 0,
    status: true,
    discountType: "1",
    minAmount: 0,
    minQuantity: 0,
  };

  isShowDateEnd = false;
  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = moment().endOf("day").format("YYYY-MM-DD");
  dateEnd = momentz().endOf("month").format("YYYY-MM-DD");

  menuTimePickerStart = false;
  menuTimePickerEnd = false;
  timePickerStart = moment().format("HH:mm");
  timePickerEnd = moment().format("HH:mm");

  loading = false;

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  created() {
    this.onSetTime();
  }

  async onCreate() {
    try {
      if (!this.discount.code) {
        return this.$pushNotification.error("Please enter discount code");
      } else if (
        this.discount.discountType !== "3" &&
        !this.discount.discount
      ) {
        return this.$pushNotification.error("Please enter discount value");
      } else if (
        this.discount.discountType === "1" &&
        (this.discount.discount < 0 || this.discount.discount > 100)
      ) {
        return this.$pushNotification.error(
          "Discount value cannot be less than 0 and greater than 100"
        );
      }
      let body: IBodyCreate = {
        ...this.discount,
        discountType: parseInt(this.discount.discountType),
        dateFrom: moment(this.from).unix(),
      };

      if (this.isShowDateEnd) {
        body.dateTo = moment(this.to).unix();
      }
      this.loading = true;
      await this.$api.AdminDiscount.addDiscount(body);
      this.$pushNotification.success("Create discount successfully");
      this.discount = {
        code: "",
        discount: 0,
        status: true,
        discountType: "1",
        minAmount: 0,
        minQuantity: 0,
      };
      this.$router.push("/admin/discounts");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  onSetTime() {
    this.$store.commit("setting/setTime", {
      dateStart: this.dateStart,
      dateEnd: this.dateEnd,
      timeFrom: this.timePickerStart,
      timeTo: this.timePickerEnd,
    });
  }

  @Watch("dateStart")
  onChagedDateStart() {
    this.onSetTime();
  }

  @Watch("dateEnd")
  onChagedDateEnd() {
    this.onSetTime();
  }

  @Watch("timePickerStart")
  onChagedTimeStart() {
    this.onSetTime();
  }

  @Watch("timePickerEnd")
  onChagedTimeEnd() {
    this.onSetTime();
  }

  @Watch("discount.code")
  changedCodeName(value: string) {
    this.discount.code = value.toLocaleUpperCase();
  }
}
</script>

<style></style>
